diff -NurpP --minimal linux-2.6.8.1/Makefile linux-2.6.8.1-vs1.9.2/Makefile
--- linux-2.6.8.1/Makefile	2004-08-14 12:55:35.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/Makefile	2004-08-25 18:49:25.000000000 +0200
@@ -1,7 +1,7 @@
 VERSION = 2
 PATCHLEVEL = 6
 SUBLEVEL = 8
-EXTRAVERSION = .1
+EXTRAVERSION = .1-vs1.9.2
 NAME=Zonked Quokka
 
 # *DOCUMENTATION*
diff -NurpP --minimal linux-2.6.8.1/arch/alpha/Kconfig linux-2.6.8.1-vs1.9.2/arch/alpha/Kconfig
--- linux-2.6.8.1/arch/alpha/Kconfig	2004-08-14 12:55:48.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/alpha/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -692,6 +692,8 @@ config DEBUG_INFO
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/alpha/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/alpha/kernel/ptrace.c
--- linux-2.6.8.1/arch/alpha/kernel/ptrace.c	2004-08-14 12:56:14.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/alpha/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -287,6 +287,8 @@ do_sys_ptrace(long request, long pid, lo
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out_notsk;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out;
 
 	if (request == PTRACE_ATTACH) {
 		ret = ptrace_attach(child);
diff -NurpP --minimal linux-2.6.8.1/arch/alpha/kernel/systbls.S linux-2.6.8.1-vs1.9.2/arch/alpha/kernel/systbls.S
--- linux-2.6.8.1/arch/alpha/kernel/systbls.S	2004-08-14 12:55:35.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/alpha/kernel/systbls.S	2004-08-25 18:49:25.000000000 +0200
@@ -291,7 +291,7 @@ sys_call_table:
 	.quad alpha_ni_syscall			/* 270 */
 	.quad alpha_ni_syscall
 	.quad alpha_ni_syscall
-	.quad alpha_ni_syscall
+	.quad sys_vserver			/* 273 sys_vserver */
 	.quad alpha_ni_syscall
 	.quad alpha_ni_syscall			/* 275 */
 	.quad alpha_ni_syscall
diff -NurpP --minimal linux-2.6.8.1/arch/arm/Kconfig linux-2.6.8.1-vs1.9.2/arch/arm/Kconfig
--- linux-2.6.8.1/arch/arm/Kconfig	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/arm/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -821,6 +821,8 @@ config DEBUG_S3C2410_UART
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/arm/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/arm/kernel/ptrace.c
--- linux-2.6.8.1/arch/arm/kernel/ptrace.c	2004-08-14 12:54:49.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/arm/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -754,6 +754,8 @@ asmlinkage int sys_ptrace(long request, 
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/arm26/Kconfig linux-2.6.8.1-vs1.9.2/arch/arm26/Kconfig
--- linux-2.6.8.1/arch/arm26/Kconfig	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/arm26/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -327,6 +327,8 @@ config DEBUG_LL
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/arm26/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/arm26/kernel/ptrace.c
--- linux-2.6.8.1/arch/arm26/kernel/ptrace.c	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/arm26/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -691,6 +691,8 @@ asmlinkage int sys_ptrace(long request, 
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/cris/Kconfig linux-2.6.8.1-vs1.9.2/arch/cris/Kconfig
--- linux-2.6.8.1/arch/cris/Kconfig	2004-08-14 12:56:22.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/cris/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -210,6 +210,8 @@ config FRAME_POINTER
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/h8300/Kconfig linux-2.6.8.1-vs1.9.2/arch/h8300/Kconfig
--- linux-2.6.8.1/arch/h8300/Kconfig	2004-08-14 12:55:59.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/h8300/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -253,6 +253,8 @@ config CONFIG_BLKDEV_RESERVE_ADDRESS
 	  BLKDEV start address.
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/h8300/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/h8300/kernel/ptrace.c
--- linux-2.6.8.1/arch/h8300/kernel/ptrace.c	2004-08-14 12:55:10.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/h8300/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -80,6 +80,8 @@ asmlinkage int sys_ptrace(long request, 
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/i386/Kconfig linux-2.6.8.1-vs1.9.2/arch/i386/Kconfig
--- linux-2.6.8.1/arch/i386/Kconfig	2004-08-14 12:54:50.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/i386/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -1310,6 +1310,8 @@ config X86_MPPARSE
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/i386/kernel/entry.S linux-2.6.8.1-vs1.9.2/arch/i386/kernel/entry.S
--- linux-2.6.8.1/arch/i386/kernel/entry.S	2004-08-14 12:55:09.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/i386/kernel/entry.S	2004-08-25 18:49:25.000000000 +0200
@@ -875,7 +875,7 @@ ENTRY(sys_call_table)
 	.long sys_tgkill	/* 270 */
 	.long sys_utimes
  	.long sys_fadvise64_64
-	.long sys_ni_syscall	/* sys_vserver */
+	.long sys_vserver
 	.long sys_mbind
 	.long sys_get_mempolicy
 	.long sys_set_mempolicy
diff -NurpP --minimal linux-2.6.8.1/arch/i386/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/i386/kernel/ptrace.c
--- linux-2.6.8.1/arch/i386/kernel/ptrace.c	2004-08-14 12:55:09.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/i386/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -259,6 +259,8 @@ asmlinkage int sys_ptrace(long request, 
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/i386/kernel/sys_i386.c linux-2.6.8.1-vs1.9.2/arch/i386/kernel/sys_i386.c
--- linux-2.6.8.1/arch/i386/kernel/sys_i386.c	2004-08-14 12:56:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/i386/kernel/sys_i386.c	2004-08-25 18:49:25.000000000 +0200
@@ -19,6 +19,7 @@
 #include <linux/mman.h>
 #include <linux/file.h>
 #include <linux/utsname.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -217,7 +218,7 @@ asmlinkage int sys_uname(struct old_utsn
 	if (!name)
 		return -EFAULT;
 	down_read(&uts_sem);
-	err=copy_to_user(name, &system_utsname, sizeof (*name));
+	err=copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	return err?-EFAULT:0;
 }
@@ -225,6 +226,7 @@ asmlinkage int sys_uname(struct old_utsn
 asmlinkage int sys_olduname(struct oldold_utsname __user * name)
 {
 	int error;
+	struct new_utsname *ptr;
 
 	if (!name)
 		return -EFAULT;
@@ -233,15 +235,16 @@ asmlinkage int sys_olduname(struct oldol
   
   	down_read(&uts_sem);
 	
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,__OLD_UTS_LEN);
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname,ptr->sysname,__OLD_UTS_LEN);
 	error |= __put_user(0,name->sysname+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->nodename,&system_utsname.nodename,__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->nodename,ptr->nodename,__OLD_UTS_LEN);
 	error |= __put_user(0,name->nodename+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->release,&system_utsname.release,__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->release,ptr->release,__OLD_UTS_LEN);
 	error |= __put_user(0,name->release+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->version,&system_utsname.version,__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->version,ptr->version,__OLD_UTS_LEN);
 	error |= __put_user(0,name->version+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->machine,&system_utsname.machine,__OLD_UTS_LEN);
+	error |= __copy_to_user(&name->machine,ptr->machine,__OLD_UTS_LEN);
 	error |= __put_user(0,name->machine+__OLD_UTS_LEN);
 	
 	up_read(&uts_sem);
diff -NurpP --minimal linux-2.6.8.1/arch/i386/mm/hugetlbpage.c linux-2.6.8.1-vs1.9.2/arch/i386/mm/hugetlbpage.c
--- linux-2.6.8.1/arch/i386/mm/hugetlbpage.c	2004-08-14 12:56:22.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/i386/mm/hugetlbpage.c	2004-08-25 18:49:34.000000000 +0200
@@ -42,7 +42,8 @@ static void set_huge_pte(struct mm_struc
 {
 	pte_t entry;
 
-	mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	// mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	vx_rsspages_add(mm, HPAGE_SIZE / PAGE_SIZE);
 	if (write_access) {
 		entry =
 		    pte_mkwrite(pte_mkdirty(mk_pte(page, vma->vm_page_prot)));
@@ -82,7 +83,8 @@ int copy_hugetlb_page_range(struct mm_st
 		ptepage = pte_page(entry);
 		get_page(ptepage);
 		set_pte(dst_pte, entry);
-		dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+		// dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+		vx_rsspages_add(dst, HPAGE_SIZE / PAGE_SIZE);
 		addr += HPAGE_SIZE;
 	}
 	return 0;
@@ -218,7 +220,8 @@ void unmap_hugepage_range(struct vm_area
 		page = pte_page(pte);
 		put_page(page);
 	}
-	mm->rss -= (end - start) >> PAGE_SHIFT;
+	// mm->rss -= (end - start) >> PAGE_SHIFT;
+	vx_rsspages_sub(mm, (end - start) >> PAGE_SHIFT);
 	flush_tlb_range(vma, start, end);
 }
 
diff -NurpP --minimal linux-2.6.8.1/arch/ia64/Kconfig linux-2.6.8.1-vs1.9.2/arch/ia64/Kconfig
--- linux-2.6.8.1/arch/ia64/Kconfig	2004-08-14 12:56:22.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ia64/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -486,6 +486,8 @@ config SYSVIPC_COMPAT
 	default y
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/ia64/ia32/binfmt_elf32.c linux-2.6.8.1-vs1.9.2/arch/ia64/ia32/binfmt_elf32.c
--- linux-2.6.8.1/arch/ia64/ia32/binfmt_elf32.c	2004-08-14 12:56:22.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ia64/ia32/binfmt_elf32.c	2004-08-25 18:49:34.000000000 +0200
@@ -14,6 +14,7 @@
 #include <linux/types.h>
 #include <linux/mm.h>
 #include <linux/security.h>
+#include <linux/vs_memory.h>
 
 #include <asm/param.h>
 #include <asm/signal.h>
@@ -148,7 +149,7 @@ ia64_elf32_init (struct pt_regs *regs)
 int
 ia32_setup_arg_pages (struct linux_binprm *bprm, int executable_stack)
 {
-	unsigned long stack_base;
+	unsigned long stack_base, grow;
 	struct vm_area_struct *mpnt;
 	struct mm_struct *mm = current->mm;
 	int i;
@@ -165,8 +166,10 @@ ia32_setup_arg_pages (struct linux_binpr
 	if (!mpnt)
 		return -ENOMEM;
 
-	if (security_vm_enough_memory((IA32_STACK_TOP - (PAGE_MASK & (unsigned long) bprm->p))
-				      >> PAGE_SHIFT)) {
+	grow = (IA32_STACK_TOP - (PAGE_MASK & (unsigned long) bprm->p))
+		>> PAGE_SHIFT;
+	if (security_vm_enough_memory(grow) ||
+		!vx_vmpages_avail(mm, grow)) {
 		kmem_cache_free(vm_area_cachep, mpnt);
 		return -ENOMEM;
 	}
@@ -187,7 +190,9 @@ ia32_setup_arg_pages (struct linux_binpr
 		mpnt->vm_page_prot = (mpnt->vm_flags & VM_EXEC)?
 					PAGE_COPY_EXEC: PAGE_COPY;
 		insert_vm_struct(current->mm, mpnt);
-		current->mm->total_vm = (mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT;
+		// current->mm->total_vm = (mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT;
+		vx_vmpages_sub(current->mm, current->mm->total_vm -
+			((mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT));
 	}
 
 	for (i = 0 ; i < MAX_ARG_PAGES ; i++) {
diff -NurpP --minimal linux-2.6.8.1/arch/ia64/kernel/entry.S linux-2.6.8.1-vs1.9.2/arch/ia64/kernel/entry.S
--- linux-2.6.8.1/arch/ia64/kernel/entry.S	2004-08-14 12:55:09.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ia64/kernel/entry.S	2004-08-25 18:49:25.000000000 +0200
@@ -1526,7 +1526,7 @@ sys_call_table:
 	data8 sys_mq_notify
 	data8 sys_mq_getsetattr
 	data8 sys_ni_syscall			// reserved for kexec_load
-	data8 sys_ni_syscall
+	data8 sys_vserver
 	data8 sys_ni_syscall			// 1270
 	data8 sys_ni_syscall
 	data8 sys_ni_syscall
diff -NurpP --minimal linux-2.6.8.1/arch/ia64/kernel/perfmon.c linux-2.6.8.1-vs1.9.2/arch/ia64/kernel/perfmon.c
--- linux-2.6.8.1/arch/ia64/kernel/perfmon.c	2004-08-14 12:56:22.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ia64/kernel/perfmon.c	2004-08-25 18:49:34.000000000 +0200
@@ -2351,7 +2351,8 @@ pfm_smpl_buffer_alloc(struct task_struct
 	 */
 	insert_vm_struct(mm, vma);
 
-	mm->total_vm  += size >> PAGE_SHIFT;
+	// mm->total_vm  += size >> PAGE_SHIFT;
+	vx_vmpages_add(mm, size >> PAGE_SHIFT);
 
 	up_write(&task->mm->mmap_sem);
 
diff -NurpP --minimal linux-2.6.8.1/arch/ia64/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/ia64/kernel/ptrace.c
--- linux-2.6.8.1/arch/ia64/kernel/ptrace.c	2004-08-14 12:56:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ia64/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -1310,6 +1310,9 @@ sys_ptrace (long request, pid_t pid, uns
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
+
 	ret = -EPERM;
 	if (pid == 1)		/* no messing around with init! */
 		goto out_tsk;
diff -NurpP --minimal linux-2.6.8.1/arch/ia64/mm/fault.c linux-2.6.8.1-vs1.9.2/arch/ia64/mm/fault.c
--- linux-2.6.8.1/arch/ia64/mm/fault.c	2004-08-14 12:56:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ia64/mm/fault.c	2004-08-25 18:49:34.000000000 +0200
@@ -34,12 +34,19 @@ expand_backing_store (struct vm_area_str
 
 	grow = PAGE_SIZE >> PAGE_SHIFT;
 	if (address - vma->vm_start > current->rlim[RLIMIT_STACK].rlim_cur
-	    || (((vma->vm_mm->total_vm + grow) << PAGE_SHIFT) > current->rlim[RLIMIT_AS].rlim_cur))
+	    || (((vma->vm_mm->total_vm + grow) << PAGE_SHIFT) >
+		current->rlim[RLIMIT_AS].rlim_cur))
+		return -ENOMEM;
+	if (!vx_vmpages_avail(vma->vm_mm, grow) ||
+		((vma->vm_flags & VM_LOCKED) &&
+		!vx_vmlocked_avail(vma->vm_mm, grow)))
 		return -ENOMEM;
 	vma->vm_end += PAGE_SIZE;
-	vma->vm_mm->total_vm += grow;
+	// vma->vm_mm->total_vm += grow;
+	vx_vmpages_add(vma->vm_mm, grow);
 	if (vma->vm_flags & VM_LOCKED)
-		vma->vm_mm->locked_vm += grow;
+		// vma->vm_mm->locked_vm += grow;
+		vx_vmlocked_add(vma->vm_mm, grow);
 	return 0;
 }
 
diff -NurpP --minimal linux-2.6.8.1/arch/ia64/mm/hugetlbpage.c linux-2.6.8.1-vs1.9.2/arch/ia64/mm/hugetlbpage.c
--- linux-2.6.8.1/arch/ia64/mm/hugetlbpage.c	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ia64/mm/hugetlbpage.c	2004-08-25 18:49:34.000000000 +0200
@@ -65,7 +65,8 @@ set_huge_pte (struct mm_struct *mm, stru
 {
 	pte_t entry;
 
-	mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	// mm->rss += (HPAGE_SIZE / PAGE_SIZE);
+	vx_rsspages_add(mm, HPAGE_SIZE / PAGE_SIZE);
 	if (write_access) {
 		entry =
 		    pte_mkwrite(pte_mkdirty(mk_pte(page, vma->vm_page_prot)));
@@ -108,7 +109,8 @@ int copy_hugetlb_page_range(struct mm_st
 		ptepage = pte_page(entry);
 		get_page(ptepage);
 		set_pte(dst_pte, entry);
-		dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+		// dst->rss += (HPAGE_SIZE / PAGE_SIZE);
+		vx_rsspages_add(dst, HPAGE_SIZE / PAGE_SIZE);
 		addr += HPAGE_SIZE;
 	}
 	return 0;
@@ -249,7 +251,8 @@ void unmap_hugepage_range(struct vm_area
 		put_page(page);
 		pte_clear(pte);
 	}
-	mm->rss -= (end - start) >> PAGE_SHIFT;
+	// mm->rss -= (end - start) >> PAGE_SHIFT;
+	vx_rsspages_sub(mm, (end - start) >> PAGE_SHIFT);
 	flush_tlb_range(vma, start, end);
 }
 
diff -NurpP --minimal linux-2.6.8.1/arch/m68k/Kconfig linux-2.6.8.1-vs1.9.2/arch/m68k/Kconfig
--- linux-2.6.8.1/arch/m68k/Kconfig	2004-08-14 12:55:34.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/m68k/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -690,6 +690,8 @@ config DEBUG_INFO
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/m68k/atari/stram.c linux-2.6.8.1-vs1.9.2/arch/m68k/atari/stram.c
--- linux-2.6.8.1/arch/m68k/atari/stram.c	2004-08-14 12:55:48.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/m68k/atari/stram.c	2004-08-25 18:49:34.000000000 +0200
@@ -635,7 +635,8 @@ static inline void unswap_pte(struct vm_
 	set_pte(dir, pte_mkdirty(mk_pte(page, vma->vm_page_prot)));
 	swap_free(entry);
 	get_page(page);
-	++vma->vm_mm->rss;
+	// ++vma->vm_mm->rss;
+	vx_rsspages_inc(vma->vm_mm);
 }
 
 static inline void unswap_pmd(struct vm_area_struct * vma, pmd_t *dir,
diff -NurpP --minimal linux-2.6.8.1/arch/m68k/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/m68k/kernel/ptrace.c
--- linux-2.6.8.1/arch/m68k/kernel/ptrace.c	2004-08-14 12:55:09.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/m68k/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -140,6 +140,8 @@ asmlinkage int sys_ptrace(long request, 
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/m68knommu/Kconfig linux-2.6.8.1-vs1.9.2/arch/m68knommu/Kconfig
--- linux-2.6.8.1/arch/m68knommu/Kconfig	2004-08-14 12:55:47.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/m68knommu/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -566,6 +566,8 @@ config BDM_DISABLE
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/m68knommu/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/m68knommu/kernel/ptrace.c
--- linux-2.6.8.1/arch/m68knommu/kernel/ptrace.c	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/m68knommu/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -124,6 +124,8 @@ asmlinkage int sys_ptrace(long request, 
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/mips/Kconfig linux-2.6.8.1-vs1.9.2/arch/mips/Kconfig
--- linux-2.6.8.1/arch/mips/Kconfig	2004-08-14 12:55:32.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/mips/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -1686,6 +1686,8 @@ config DEBUG_HIGHMEM
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/mips/kernel/irixelf.c linux-2.6.8.1-vs1.9.2/arch/mips/kernel/irixelf.c
--- linux-2.6.8.1/arch/mips/kernel/irixelf.c	2004-08-14 12:56:25.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/mips/kernel/irixelf.c	2004-08-25 18:49:34.000000000 +0200
@@ -686,7 +686,8 @@ static int load_irix_binary(struct linux
 	/* Do this so that we can load the interpreter, if need be.  We will
 	 * change some of these later.
 	 */
-	current->mm->rss = 0;
+	// current->mm->rss = 0;
+	vx_rsspages_sub(current->mm, current->mm->rss);
 	setup_arg_pages(bprm, EXSTACK_DEFAULT);
 	current->mm->start_stack = bprm->p;
 
diff -NurpP --minimal linux-2.6.8.1/arch/mips/kernel/linux32.c linux-2.6.8.1-vs1.9.2/arch/mips/kernel/linux32.c
--- linux-2.6.8.1/arch/mips/kernel/linux32.c	2004-08-14 12:55:35.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/mips/kernel/linux32.c	2004-08-25 18:49:25.000000000 +0200
@@ -1208,7 +1208,7 @@ asmlinkage long sys32_newuname(struct ne
 	int ret = 0;
 
 	down_read(&uts_sem);
-	if (copy_to_user(name,&system_utsname,sizeof *name))
+	if (copy_to_user(name, vx_new_utsname(), sizeof *name))
 		ret = -EFAULT;
 	up_read(&uts_sem);
 
diff -NurpP --minimal linux-2.6.8.1/arch/mips/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/mips/kernel/ptrace.c
--- linux-2.6.8.1/arch/mips/kernel/ptrace.c	2004-08-14 12:56:24.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/mips/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -76,6 +76,8 @@ asmlinkage int sys_ptrace(long request, 
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/mips/kernel/syscall.c linux-2.6.8.1-vs1.9.2/arch/mips/kernel/syscall.c
--- linux-2.6.8.1/arch/mips/kernel/syscall.c	2004-08-14 12:55:59.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/mips/kernel/syscall.c	2004-08-25 18:49:25.000000000 +0200
@@ -24,6 +24,7 @@
 #include <linux/sem.h>
 #include <linux/msg.h>
 #include <linux/shm.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/branch.h>
 #include <asm/cachectl.h>
@@ -209,7 +210,7 @@ out:
  */
 asmlinkage int sys_uname(struct old_utsname * name)
 {
-	if (name && !copy_to_user(name, &system_utsname, sizeof (*name)))
+	if (name && !copy_to_user(name, vx_new_utsname(), sizeof (*name)))
 		return 0;
 	return -EFAULT;
 }
@@ -220,21 +221,23 @@ asmlinkage int sys_uname(struct old_utsn
 asmlinkage int sys_olduname(struct oldold_utsname * name)
 {
 	int error;
+	struct new_utsname *ptr;
 
 	if (!name)
 		return -EFAULT;
 	if (!access_ok(VERIFY_WRITE,name,sizeof(struct oldold_utsname)))
 		return -EFAULT;
 
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,__OLD_UTS_LEN);
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname,ptr->sysname,__OLD_UTS_LEN);
 	error -= __put_user(0,name->sysname+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->nodename,&system_utsname.nodename,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->nodename,ptr->nodename,__OLD_UTS_LEN);
 	error -= __put_user(0,name->nodename+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->release,&system_utsname.release,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->release,ptr->release,__OLD_UTS_LEN);
 	error -= __put_user(0,name->release+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->version,&system_utsname.version,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->version,ptr->version,__OLD_UTS_LEN);
 	error -= __put_user(0,name->version+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->machine,&system_utsname.machine,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->machine,ptr->machine,__OLD_UTS_LEN);
 	error = __put_user(0,name->machine+__OLD_UTS_LEN);
 	error = error ? -EFAULT : 0;
 
@@ -260,10 +263,10 @@ asmlinkage int _sys_sysmips(int cmd, lon
 			return -EFAULT;
 
 		down_write(&uts_sem);
-		strncpy(system_utsname.nodename, nodename, len);
+		strncpy(vx_new_uts(nodename), nodename, len);
 		nodename[__NEW_UTS_LEN] = '\0';
-		strlcpy(system_utsname.nodename, nodename,
-		        sizeof(system_utsname.nodename));
+		strlcpy(vx_new_uts(nodename), nodename,
+		        sizeof(vx_new_uts(nodename)));
 		up_write(&uts_sem);
 		return 0;
 	}
diff -NurpP --minimal linux-2.6.8.1/arch/mips/kernel/sysirix.c linux-2.6.8.1-vs1.9.2/arch/mips/kernel/sysirix.c
--- linux-2.6.8.1/arch/mips/kernel/sysirix.c	2004-08-14 12:56:22.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/mips/kernel/sysirix.c	2004-08-25 18:49:35.000000000 +0200
@@ -30,6 +30,7 @@
 #include <linux/socket.h>
 #include <linux/security.h>
 #include <linux/syscalls.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/ptrace.h>
 #include <asm/page.h>
@@ -577,7 +578,8 @@ asmlinkage int irix_brk(unsigned long br
 	/*
 	 * Check if we have enough memory..
 	 */
-	if (security_vm_enough_memory((newbrk-oldbrk) >> PAGE_SHIFT)) {
+	if (security_vm_enough_memory((newbrk-oldbrk) >> PAGE_SHIFT) ||
+		!vx_vmpages_avail(mm, (newbrk-oldbrk) >> PAGE_SHIFT)) {
 		ret = -ENOMEM;
 		goto out;
 	}
diff -NurpP --minimal linux-2.6.8.1/arch/parisc/Kconfig linux-2.6.8.1-vs1.9.2/arch/parisc/Kconfig
--- linux-2.6.8.1/arch/parisc/Kconfig	2004-08-14 12:55:34.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/parisc/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -255,6 +255,8 @@ config DEBUG_INFO
 	  
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/parisc/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/parisc/kernel/ptrace.c
--- linux-2.6.8.1/arch/parisc/kernel/ptrace.c	2004-08-14 12:54:50.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/parisc/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -110,6 +110,9 @@ long sys_ptrace(long request, pid_t pid,
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
+
 	ret = -EPERM;
 	if (pid == 1)		/* no messing around with init! */
 		goto out_tsk;
diff -NurpP --minimal linux-2.6.8.1/arch/parisc/kernel/sys_parisc32.c linux-2.6.8.1-vs1.9.2/arch/parisc/kernel/sys_parisc32.c
--- linux-2.6.8.1/arch/parisc/kernel/sys_parisc32.c	2004-08-14 12:55:10.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/parisc/kernel/sys_parisc32.c	2004-08-25 18:49:35.000000000 +0200
@@ -677,6 +677,7 @@ asmlinkage int sys32_sysinfo(struct sysi
 
 	do {
 		seq = read_seqbegin(&xtime_lock);
+		/* requires vx virtualization */
 		val.uptime = jiffies / HZ;
 
 		val.loads[0] = avenrun[0] << (SI_LOAD_SHIFT - FSHIFT);
diff -NurpP --minimal linux-2.6.8.1/arch/ppc/Kconfig linux-2.6.8.1-vs1.9.2/arch/ppc/Kconfig
--- linux-2.6.8.1/arch/ppc/Kconfig	2004-08-14 12:56:23.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ppc/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -1351,6 +1351,8 @@ config PPC_OCP
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/ppc/kernel/misc.S linux-2.6.8.1-vs1.9.2/arch/ppc/kernel/misc.S
--- linux-2.6.8.1/arch/ppc/kernel/misc.S	2004-08-14 12:56:22.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ppc/kernel/misc.S	2004-08-25 18:49:25.000000000 +0200
@@ -1438,7 +1438,7 @@ _GLOBAL(sys_call_table)
 	.long ppc_fadvise64_64
 	.long sys_ni_syscall		/* 255 - rtas (used on ppc64) */
 	.long sys_ni_syscall		/* 256 reserved for sys_debug_setcontext */
-	.long sys_ni_syscall		/* 257 reserved for vserver */
+	.long sys_vserver
 	.long sys_ni_syscall		/* 258 reserved for new sys_remap_file_pages */
 	.long sys_ni_syscall		/* 259 reserved for new sys_mbind */
 	.long sys_ni_syscall		/* 260 reserved for new sys_get_mempolicy */
diff -NurpP --minimal linux-2.6.8.1/arch/ppc/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/ppc/kernel/ptrace.c
--- linux-2.6.8.1/arch/ppc/kernel/ptrace.c	2004-08-14 12:55:09.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ppc/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -261,6 +261,8 @@ int sys_ptrace(long request, long pid, l
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
diff -NurpP --minimal linux-2.6.8.1/arch/ppc/kernel/syscalls.c linux-2.6.8.1-vs1.9.2/arch/ppc/kernel/syscalls.c
--- linux-2.6.8.1/arch/ppc/kernel/syscalls.c	2004-08-14 12:56:22.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ppc/kernel/syscalls.c	2004-08-25 18:49:25.000000000 +0200
@@ -36,6 +36,7 @@
 #include <linux/utsname.h>
 #include <linux/file.h>
 #include <linux/unistd.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -229,7 +230,7 @@ int sys_uname(struct old_utsname __user 
 	int err = -EFAULT;
 
 	down_read(&uts_sem);
-	if (name && !copy_to_user(name, &system_utsname, sizeof (*name)))
+	if (name && !copy_to_user(name, vx_new_utsname(), sizeof (*name)))
 		err = 0;
 	up_read(&uts_sem);
 	return err;
@@ -238,6 +239,7 @@ int sys_uname(struct old_utsname __user 
 int sys_olduname(struct oldold_utsname __user * name)
 {
 	int error;
+	struct new_utsname *ptr;
 
 	if (!name)
 		return -EFAULT;
@@ -245,15 +247,16 @@ int sys_olduname(struct oldold_utsname _
 		return -EFAULT;
 
 	down_read(&uts_sem);
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,__OLD_UTS_LEN);
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname,ptr->sysname,__OLD_UTS_LEN);
 	error -= __put_user(0,name->sysname+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->nodename,&system_utsname.nodename,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->nodename,ptr->nodename,__OLD_UTS_LEN);
 	error -= __put_user(0,name->nodename+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->release,&system_utsname.release,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->release,ptr->release,__OLD_UTS_LEN);
 	error -= __put_user(0,name->release+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->version,&system_utsname.version,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->version,ptr->version,__OLD_UTS_LEN);
 	error -= __put_user(0,name->version+__OLD_UTS_LEN);
-	error -= __copy_to_user(&name->machine,&system_utsname.machine,__OLD_UTS_LEN);
+	error -= __copy_to_user(&name->machine,ptr->machine,__OLD_UTS_LEN);
 	error = __put_user(0,name->machine+__OLD_UTS_LEN);
 	up_read(&uts_sem);
 
diff -NurpP --minimal linux-2.6.8.1/arch/ppc64/Kconfig linux-2.6.8.1-vs1.9.2/arch/ppc64/Kconfig
--- linux-2.6.8.1/arch/ppc64/Kconfig	2004-08-14 12:55:33.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ppc64/Kconfig	2004-08-25 18:49:25.000000000 +0200
@@ -436,6 +436,8 @@ config SPINLINE
 
 endmenu
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.8.1/arch/ppc64/kernel/misc.S linux-2.6.8.1-vs1.9.2/arch/ppc64/kernel/misc.S
--- linux-2.6.8.1/arch/ppc64/kernel/misc.S	2004-08-14 12:56:01.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ppc64/kernel/misc.S	2004-08-25 18:49:25.000000000 +0200
@@ -864,7 +864,7 @@ _GLOBAL(sys_call_table32)
 	.llong .ppc32_fadvise64_64	/* 32bit only fadvise64_64 */
 	.llong .ppc_rtas		/* 255 */
 	.llong .sys_ni_syscall		/* 256 reserved for sys_debug_setcontext */
-	.llong .sys_ni_syscall		/* 257 reserved for vserver */
+	.llong .sys_vserver
 	.llong .sys_ni_syscall		/* 258 reserved for new sys_remap_file_pages */
 	.llong .sys_ni_syscall		/* 259 reserved for new sys_mbind */
 	.llong .sys_ni_syscall		/* 260 reserved for new sys_get_mempolicy */
diff -NurpP --minimal linux-2.6.8.1/arch/ppc64/kernel/ptrace.c linux-2.6.8.1-vs1.9.2/arch/ppc64/kernel/ptrace.c
--- linux-2.6.8.1/arch/ppc64/kernel/ptrace.c	2004-08-14 12:56:00.000000000 +0200
+++ linux-2.6.8.1-vs1.9.2/arch/ppc64/kernel/ptrace.c	2004-08-25 18:49:35.000000000 +0200
@@ -76,6 +76,8 @@ int sys_ptrace(long request, long pid, l
 	read_unlock(&tasklist_lock);
 	if (!child)
 		goto out;
+	if (!vx_check(vx_task_xid(child), VX_WATCH|VX_IDENT))
+		goto out_tsk;
 
 	ret = -EPERM;
 	if (pid == 1)		/* you may not mess with init */
